// ----------------------------------------
// Запись данных в текстовом формате в Clipboard
// и чтение текстовых данных из Clipboard
// ----------------------------------------
#define STRICT
#include <windows.h>
#include <mem.h>
#include "cliptxt.hpp"

BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);

char const szClassName[]   = "CliptxtClass";
char const szWindowTitle[] = "Clipboard Demo";
char const szClipboardText[] =
  "Этот текст будет записан\r\n"
  "в универсальный буфер обмена Clipboard\r\n"
  "приложением CLIPTXT";

// =====================================
// Функция WinMain
// =====================================
#pragma argsused
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpszCmdLine, int nCmdShow)
{
  MSG  msg;   // структура для работы с сообщениями
  HWND hwnd;  // идентификатор главного окна приложения

  // Разрешаем запуск нескольких копий приложения
  if(!hPrevInstance)
    if(!InitApp(hInstance))
      return FALSE;

  hwnd = CreateWindow(
    szClassName, szWindowTitle,
    WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, CW_USEDEFAULT,
    CW_USEDEFAULT, CW_USEDEFAULT,
    0, 0, hInstance, NULL);

  if(!hwnd)
    return FALSE;

  ShowWindow(hwnd, nCmdShow);
  UpdateWindow(hwnd);

  while(GetMessage(&msg, 0, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================
BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна
  memset(&wc, 0, sizeof(wc));
  wc.lpszMenuName  = "APP_MENU";
  wc.style         = CS_HREDRAW | CS_VREDRAW;
  wc.lpfnWndProc   = (WNDPROC) WndProc;
  wc.cbClsExtra    = 0;
  wc.cbWndExtra    = 0;
  wc.hInstance     = hInstance;
  wc.hIcon         = LoadIcon(hInstance, "APP_ICON");
  wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszClassName = (LPSTR)szClassName;

  aWndClass = RegisterClass(&wc);
  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================
LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  HDC hdc;
  PAINTSTRUCT ps;
  RECT rc;

  static HGLOBAL hglbTextCopyBuf;
  LPSTR lpTextCopy;
  static HGLOBAL hglbTextPasteBuf;
  LPSTR lpTextPaste;
  static HGLOBAL hglbClipBuf;
  LPSTR lpClipBuf;

  switch (msg)
  {
    case WM_CREATE:
    {
      // Заказываем буфер для хранения текста,
      // прочитанного из Clipboard.
      // Начальный размер этого буфера - 1 байт
      hglbTextPasteBuf = GlobalAlloc(GHND, 1);
      if(hglbTextPasteBuf == NULL)
        return -1;

      // Фиксируем буфер в памяти и получаем его адрес
      lpTextPaste = (LPSTR)GlobalLock(hglbTextPasteBuf);
      if(hglbTextPasteBuf == NULL)
        return -1;

      // Записываем в буфер пустую строку
      lpTextPaste[0] = '\0';

      // Расфиксируем буфер
      GlobalUnlock(hglbTextPasteBuf);
      return 0;
    }
    case WM_PAINT:
    {
      hdc = BeginPaint(hwnd, &ps);

      // Фиксируем текстовый буфер в памяти,
      // в случае успеха отображаем его содержимое
      // во внутренней области главного окна
      lpTextPaste = (LPSTR)GlobalLock(hglbTextPasteBuf);
      if(lpTextPaste != NULL)
      {
        GetClientRect(hwnd, &rc);
        DrawText(hdc, lpTextPaste, -1, &rc,
          DT_LEFT | DT_EXPANDTABS);
        GlobalUnlock(hglbTextPasteBuf);
      }
      EndPaint(hwnd, &ps);
    }
    case WM_COMMAND:
    {
      switch (wParam)
      {
        // Копируем строку текста в Clipboard
        case CM_EDITCOPY:
        {
          // Заказываем глобальный блок памяти для строки
          hglbTextCopyBuf = GlobalAlloc(GHND,
            sizeof(szClipboardText) + 1);
          if(hglbTextCopyBuf != NULL)
          {
            // Фиксируем блок памяти
            lpTextCopy = (LPSTR)GlobalLock(hglbTextCopyBuf);
            if(lpTextCopy != NULL)
            {
              // Копируем строку текста в блок памяти
              lstrcpy(lpTextCopy, szClipboardText);

              // Расфиксируем блок памяти
              GlobalUnlock(hglbTextCopyBuf);

              // Открываем Clipboard и очищаем его
              OpenClipboard(hwnd);
              EmptyClipboard();

              // Записываем данные в Clipboard
              SetClipboardData(CF_TEXT, hglbTextCopyBuf);

              // Закрываем Clipboard
              CloseClipboard();
            }
            else
              MessageBox(hwnd, "Мало памяти",
                (LPSTR)szWindowTitle, MB_OK | MB_ICONHAND);
          }
          else
            MessageBox(hwnd, "Мало памяти",
              (LPSTR)szWindowTitle, MB_OK | MB_ICONHAND);
          return 0;
        }

        // Чтение текстовых данных из Clipboard
        case CM_EDITPASTE:
        {
          // Открываем Clipboard
          OpenClipboard(hwnd);

          // Получаем идентификатор блока памяти,
          // содержащего текстовые данные Clipboard
          hglbClipBuf = GetClipboardData(CF_TEXT);

          // Если в Clipboard есть данные в текстовом
          // формате, читаем их
          if(hglbClipBuf != NULL)
          {
            // Фиксируем блок памяти Clipboard
            lpClipBuf = (LPSTR)GlobalLock(hglbClipBuf);
            if(lpClipBuf != NULL)
            {
              // Изменяем размер буфера, предназначенного для
              // хранения данных, прочитанных из Clipboard,
              // устанавливая его равным размеру блока
              // данных Clipboard
              hglbTextPasteBuf = GlobalReAlloc(hglbTextPasteBuf,
                 GlobalSize(hglbClipBuf), GMEM_NODISCARD);

              // Фиксируем буфер в памяти и переписываем в него
              // содержимое Clipboard
              lpTextPaste = (LPSTR)GlobalLock(hglbTextPasteBuf);
              if(lpTextPaste != NULL)
              {
                lstrcpy(lpTextPaste, lpClipBuf);

                // Перерисовываем главное окно приложения
                InvalidateRect(hwnd, NULL, TRUE);

                // Расфиксируем буфер
                GlobalUnlock(hglbTextPasteBuf);
              }
              else
                MessageBox(hwnd, "Мало памяти",
                  (LPSTR)szWindowTitle, MB_OK | MB_ICONHAND);

              // Расфиксируем блок памяти Clipboard 
              GlobalUnlock(hglbClipBuf);
            }
            else
              MessageBox(hwnd, "Мало памяти",
                (LPSTR)szWindowTitle, MB_OK | MB_ICONHAND);
          }
          else
            MessageBox(hwnd, "Формат CF_TEXT недоступен",
            (LPSTR)szWindowTitle, MB_OK | MB_ICONHAND);

          // Закрываем Clipboard
          CloseClipboard();
          return 0;
        }

        case CM_HELPABOUT:
        {
	       MessageBox(hwnd,
            "Приложение CLIPTXT\n(C) Фролов А.В., 1995",
	         (LPSTR)szWindowTitle, MB_OK | MB_ICONINFORMATION);
          return 0;
        }
        case CM_FILEEXIT:
        {
          DestroyWindow(hwnd);
          return 0;
        }
        default:
          return 0;
      }
    }
    case WM_DESTROY:
    {
      // Освобождаем буфер, предназначенный для хранения
      // данных, прочитанных из Clipboard
      if(hglbTextPasteBuf != NULL)
        GlobalFree(hglbTextPasteBuf);

      PostQuitMessage(0);
      return 0;
    }
    default:
      break;
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}